#include "SpaceMousePro.h"
#include "interface.h"
#include <iostream>
#include <iomanip>

UINT processSpaceMouseProRawData(BYTE* rawDataBuffer, DWORD rawDataSize) {
	if (rawDataSize >= SMP_RAW_DATA_SIZE) {
		switch (rawDataBuffer[SMP_CHANNEL_OFFSET]) {
			case SMP_MOVE_CHANNEL:{
				INT16 x_val = static_cast<INT16>(rawDataBuffer[SMP_X_LSB_OFFSET] | (rawDataBuffer[SMP_X_MSB_OFFSET] << 8));
				INT16 y_val = static_cast<INT16>(rawDataBuffer[SMP_Y_LSB_OFFSET] | (rawDataBuffer[SMP_Y_MSB_OFFSET] << 8));
				INT16 z_val = static_cast<INT16>(rawDataBuffer[SMP_Z_LSB_OFFSET] | (rawDataBuffer[SMP_Z_MSB_OFFSET] << 8));
				std::cout << "M:" << x_val << SEPARATOR << y_val << SEPARATOR << z_val << std::endl;
			} break;
			case SMP_ROTATE_CHANNEL: {
				INT16 pitch_val = static_cast<INT16>(rawDataBuffer[SMP_PITCH_LSB_OFFSET] | (rawDataBuffer[SMP_PITCH_MSB_OFFSET] << 8));
				INT16 roll_val = static_cast<INT16>(rawDataBuffer[SMP_ROLL_LSB_OFFSET] | (rawDataBuffer[SMP_ROLL_MSB_OFFSET] << 8));
				INT16 yaw_val = static_cast<INT16>(rawDataBuffer[SMP_YAW_LSB_OFFSET] | (rawDataBuffer[SMP_YAW_MSB_OFFSET] << 8));
				std::cout << "R:" << pitch_val << SEPARATOR << roll_val << SEPARATOR << yaw_val << std::endl;
			} break;
			case SMP_BUTTON_CHANNEL: {
				std::cout << "B:" << static_cast<unsigned int>(rawDataBuffer[SMP_BUTTON_GROUP1]) << SEPARATOR
					<< static_cast<unsigned int>(rawDataBuffer[SMP_BUTTON_GROUP2]) << SEPARATOR
					<< static_cast<unsigned int>(rawDataBuffer[SMP_BUTTON_GROUP3]) << SEPARATOR
					<< static_cast<unsigned int>(rawDataBuffer[SMP_BUTTON_GROUP4]) << std::endl;
			} break;
		default:
			break;
		}
	}

	return 0;
}
